<?php
defined('_JEXEC') or die('Restricted access');
jimport('joomla.plugin.plugin');

class plgContentYtuserplaylists extends JPlugin {
	
	public function onContentPrepare($context, &$article, &$params, $page = 0) {
		if (strpos($article->text, 'ytuserplaylists') === false) {
			return true;
		}
		$regex = '/{ytuserplaylists\s+(.*?)}/i';
		preg_match_all($regex, $article->text, $matches);
		$count = count($matches[0]);
		if ($count) {
			// Get plugin parameters
			$css = $this->params->get('css',
				'plugins/content/ytuserplaylists/css/ytuserplaylists.css');
			$js = $this->params->get('js',
				'plugins/content/ytuserplaylists/js/touchScroll.js');
			//  Include css and JavaScript
			$document = JFactory::getDocument();
			$document->addStyleSheet($css);
			$document->addScript($js);
			// Replace matched
			for ($i = 0; $i < $count; $i++) {
				$output = $this->_load(trim($matches[1][$i]));
				$article->text = preg_replace('{' . $matches[0][$i] . '}',
					$output, $article->text);
			}
		}
	}
	
	protected function _load($userId) {
		// See https://developers.google.com/youtube/2.0/reference
		$sxml = simplexml_load_file('http://gdata.youtube.com/feeds/api/users/' .
			$userId . '/playlists?max-results=50');
		// If userId is not a valid username
		if (!$sxml) {
			return trim(libxml_get_last_error()->message);
		}
		// Use that namespace. Don't have the URL hard-coded
		$ns = $sxml->getNamespaces(true);
		$totalResults = $sxml->children($ns['openSearch'])->totalResults;
		// If no playlists found
		if ($totalResults == 0) {
			return 'totalResults: ' . $totalResults;
		}
		// Getunique identifier based on the current time in microseconds
		$ifname = uniqid('player_', false);
		$divid = uniqid('playlist_', false);
		// Player
		$html = '<div class="player-container">';
		$html .= '<iframe name="' . $ifname .
			'" type="text/html" width="960" height="720" frameborder="0"';
		$html .= ' src="http://www.youtube.com/embed/videoseries?list=' .
			$sxml->entry->children($ns['yt'])->playlistId;
		$html .= '&showinfo=1" allowfullscreen></iframe></div>';
		// Playlist
		$html .= '<div id="' . $divid .
			'" class="playlists-container"><ul class="videos">';
		foreach ($sxml->entry as $entry) {
			$countHint = $entry->children($ns['gd'])->feedLink->attributes()->countHint;
			// No empty playlists
			if ($countHint > 0) {
				$title = $entry->title;
				$playlistId = $entry->children($ns['yt'])->playlistId;
				$thumbnail = $entry->children($ns['media'])->group->thumbnail[0]->attributes()->url;
				$html .= '<li><a href="http://www.youtube.com/embed/videoseries?list=' .
					$playlistId . '&showinfo=1"';
				$html .= ' target="' . $ifname . '" title="' . $title .
					'(' . $countHint . ' videos)">';
				$html .= '<img src="' . $thumbnail . '" alt="' . $title . '" />';
				$html .= '<span class="pl_title">' . $title . '</span>';
				$html .= '<span class="pl_countHint">' . $countHint .
					' videos</span></a></li>';
			}
		}
		// JavaScript for playlist scrolling on touch devices
		$html .= '</ul></div><script type="text/javascript">touchScroll("' .
			$divid . '");</script>';
		return $html;
	}
	
}
?>
